Package org.fife.ui.rsyntaxtextarea.modes

## Class DTokenMaker

- java.lang.Object
- - org.fife.ui.rsyntaxtextarea.TokenMakerBase
  - - org.fife.ui.rsyntaxtextarea.AbstractJFlexTokenMaker
    - - org.fife.ui.rsyntaxtextarea.AbstractJFlexCTokenMaker
      - - org.fife.ui.rsyntaxtextarea.modes.DTokenMaker

- All Implemented Interfaces:
    `TokenMaker`

      public class DTokenMaker
      extends AbstractJFlexCTokenMaker

  Scanner for the D programming language.

  This implementation was created using JFlex 1.4.1; however, the generated file was modified for performance. Memory allocation needs to be almost completely removed to be competitive with the handwritten lexers (subclasses of `AbstractTokenMaker`, so this class has been modified so that Strings are never allocated (via yytext()), and the scanner never has to worry about refilling its buffer (needlessly copying chars around). We can achieve this because RText always scans exactly 1 line of tokens at a time, and hands the scanner this line as an array of characters (a Segment really). Since tokens contain pointers to char arrays instead of Strings holding their contents, there is no need for allocating new memory for Strings.

  The actual algorithm generated for scanning has, of course, not been modified.

  If you wish to regenerate this file yourself, keep in mind the following:

  - The generated `DTokenMaker.java` file will contain two definitions of both `zzRefill` and `yyreset`. You should hand-delete the second of each definition (the ones generated by the lexer), as these generated methods modify the input buffer, which we'll never have to do.
  - You should also change the declaration/definition of zzBuffer to NOT be initialized. This is a needless memory allocation for us since we will be pointing the array somewhere else anyway.
  - You should NOT call `yylex()` on the generated scanner directly; rather, you should use `getTokenList` as you would with any other `TokenMaker` instance.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.fife.ui.rsyntaxtextarea.AbstractJFlexCTokenMaker

      `AbstractJFlexCTokenMaker.CStyleInsertBreakAction`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static int` | `DOCCOMMENT` |
    `static int` | `EOL_COMMENT` |
    `static int` | `EOL_DOCCOMMENT` |
    `static int` | `MLC` |
    `static int` | `NESTABLE_MLC` |
    `static int` | `WYSIWYG_STRING_1` | lexical states
    `static int` | `WYSIWYG_STRING_2` |
    `static int` | `YYEOF` | This character denotes the end of file
    `static int` | `YYINITIAL` |

    - ### Fields inherited from class org.fife.ui.rsyntaxtextarea.AbstractJFlexTokenMaker

      `offsetShift, s, start`

    - ### Fields inherited from class org.fife.ui.rsyntaxtextarea.TokenMakerBase

      `currentToken, firstToken, previousToken`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DTokenMaker()` | Constructor.
    `DTokenMaker​(InputStream in)` | Creates a new scanner.
    `DTokenMaker​(Reader in)` | Creates a new scanner There is also a java.io.InputStream version of this constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addToken​(char[] array, int start, int end, int tokenType, int startOffset, boolean hyperlink)` | Adds the token specified to the current linked list of tokens.
    `int` | `getClosestStandardTokenTypeForInternalType​(int type)` | Returns the closest `"standard" token type` for a given "internal" token type (e.g.
    `String[]` | `getLineCommentStartAndEnd​(int languageIndex)` | Returns the text to place at the beginning and end of a line to "comment" it in this programming language.
    `Token` | `getTokenList​(Segment text, int initialTokenType, int startOffset)` | Returns the first token in the linked list of tokens generated from `text`.
    `void` | `yybegin​(int newState)` | Enters a new lexical state
    `char` | `yycharat​(int pos)` | Returns the character at position `pos` from the matched text.
    `void` | `yyclose()` | Closes the input stream.
    `int` | `yylength()` | Returns the length of the matched text region.
    `Token` | `yylex()` | Resumes scanning until the next regular expression is matched, the end of input is encountered or an I/O-Error occurs.
    `void` | `yypushback​(int number)` | Pushes the specified amount of characters back into the input stream.
    `void` | `yyreset​(Reader reader)` | Resets the scanner to read from a new input stream.
    `int` | `yystate()` | Returns the current lexical state.
    `String` | `yytext()` | Returns the text matched by the current regular expression.

    - ### Methods inherited from class org.fife.ui.rsyntaxtextarea.AbstractJFlexCTokenMaker

      `createInsertBreakAction, getCurlyBracesDenoteCodeBlocks, getInsertBreakAction, getMarkOccurrencesOfTokenType, getShouldIndentNextLineAfter`

    - ### Methods inherited from class org.fife.ui.rsyntaxtextarea.AbstractJFlexTokenMaker

      `yybegin`

    - ### Methods inherited from class org.fife.ui.rsyntaxtextarea.TokenMakerBase

      `addNullToken, addToken, addToken, createOccurrenceMarker, getLanguageIndex, getLastTokenTypeOnLine, getOccurrenceMarker, isIdentifierChar, isMarkupLanguage, resetTokenList, setLanguageIndex`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### YYEOF

          public static final int YYEOF

      This character denotes the end of file
      See Also:
        Constant Field Values

    - #### WYSIWYG_STRING_1

          public static final int WYSIWYG_STRING_1

      lexical states
      See Also:
        Constant Field Values

    - #### EOL_COMMENT

          public static final int EOL_COMMENT

      See Also:
        Constant Field Values

    - #### NESTABLE_MLC

          public static final int NESTABLE_MLC

      See Also:
        Constant Field Values

    - #### DOCCOMMENT

          public static final int DOCCOMMENT

      See Also:
        Constant Field Values

    - #### YYINITIAL

          public static final int YYINITIAL

      See Also:
        Constant Field Values

    - #### MLC

          public static final int MLC

      See Also:
        Constant Field Values

    - #### WYSIWYG_STRING_2

          public static final int WYSIWYG_STRING_2

      See Also:
        Constant Field Values

    - #### EOL_DOCCOMMENT

          public static final int EOL_DOCCOMMENT

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### DTokenMaker

          public DTokenMaker()

      Constructor. This must be here because JFlex does not generate a no-parameter constructor.

    - #### DTokenMaker

          public DTokenMaker​(Reader in)

      Creates a new scanner There is also a java.io.InputStream version of this constructor.
      Parameters:
        `in` - the java.io.Reader to read input from.

    - #### DTokenMaker

          public DTokenMaker​(InputStream in)

      Creates a new scanner. There is also java.io.Reader version of this constructor.
      Parameters:
        `in` - the java.io.Inputstream to read input from.

  - ### Method Detail

    - #### addToken

          public void addToken​(char[] array,
                               int start,
                               int end,
                               int tokenType,
                               int startOffset,
                               boolean hyperlink)

      Adds the token specified to the current linked list of tokens.
      Overrides:
        `addToken` in class `TokenMakerBase`
      Parameters:
        `array` - The character array.
        `start` - The starting offset in the array.
        `end` - The ending offset in the array.
        `tokenType` - The token's type.
        `startOffset` - The offset in the document at which this token occurs.
        `hyperlink` - Whether this token is a hyperlink.

    - #### getClosestStandardTokenTypeForInternalType

          public int getClosestStandardTokenTypeForInternalType​(int type)

      Description copied from class: `TokenMakerBase`
      Returns the closest `"standard" token type` for a given "internal" token type (e.g. one whose value is `< 0`).

      The default implementation returns `type` always, which denotes that a mapping from internal token types to standard token types is not defined; subclasses can override.

      Specified by:
        `getClosestStandardTokenTypeForInternalType` in interface `TokenMaker`
      Overrides:
        `getClosestStandardTokenTypeForInternalType` in class `TokenMakerBase`
      Parameters:
        `type` - The token type.
      Returns:
        The closest "standard" token type.

    - #### getLineCommentStartAndEnd

          public String[] getLineCommentStartAndEnd​(int languageIndex)

      Returns the text to place at the beginning and end of a line to "comment" it in this programming language.
      Specified by:
        `getLineCommentStartAndEnd` in interface `TokenMaker`
      Overrides:
        `getLineCommentStartAndEnd` in class `TokenMakerBase`
      Parameters:
        `languageIndex` - The language index at the offset in question. Since some `TokenMaker`s effectively have nested languages (such as JavaScript in HTML), this parameter tells the `TokenMaker` what sub-language to look at.
      Returns:
        The start and end strings to add to a line to "comment" it out. A `null` value for either means there is no string to add for that part. A value of `null` for the array means this language does not support commenting/uncommenting lines.

    - #### getTokenList

          public Token getTokenList​(Segment text,
                                    int initialTokenType,
                                    int startOffset)

      Returns the first token in the linked list of tokens generated from `text`. This method must be implemented by subclasses so they can correctly implement syntax highlighting.
      Parameters:
        `text` - The text from which to get tokens.
        `initialTokenType` - The token type we should start with.
        `startOffset` - The offset into the document at which `text` starts.
      Returns:
        The first `Token` in a linked list representing the syntax highlighted text.

    - #### yyreset

          public final void yyreset​(Reader reader)

      Resets the scanner to read from a new input stream. Does not close the old reader. All internal variables are reset, the old input stream cannot be reused (internal buffer is discarded and lost). Lexical state is set to `YY_INITIAL`.
      Parameters:
        `reader` - the new input stream

    - #### yyclose

          public final void yyclose()
                             throws IOException

      Closes the input stream.
      Throws:
        `IOException`

    - #### yystate

          public final int yystate()

      Returns the current lexical state.

    - #### yybegin

          public final void yybegin​(int newState)

      Enters a new lexical state
      Specified by:
        `yybegin` in class `AbstractJFlexTokenMaker`
      Parameters:
        `newState` - the new lexical state

    - #### yytext

          public final String yytext()

      Returns the text matched by the current regular expression.

    - #### yycharat

          public final char yycharat​(int pos)

      Returns the character at position `pos` from the matched text. It is equivalent to yytext().charAt(pos), but faster
      Parameters:
        `pos` - the position of the character to fetch. A value from 0 to yylength()-1.
      Returns:
        the character at position pos

    - #### yylength

          public final int yylength()

      Returns the length of the matched text region.

    - #### yypushback

          public void yypushback​(int number)

      Pushes the specified amount of characters back into the input stream. They will be read again by then next call of the scanning method
      Parameters:
        `number` - the number of characters to be read again. This number must not be greater than yylength()!

    - #### yylex

          public Token yylex()
                      throws IOException

      Resumes scanning until the next regular expression is matched, the end of input is encountered or an I/O-Error occurs.
      Returns:
        the next token
      Throws:
        `IOException` - if any I/O-Error occurs